Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsConstructor.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsConstructor.cpp	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsConstructor.cpp	(revision 1048)
@@ -139,5 +139,5 @@
 					
 					//cStripsT.eraseAtPos(i);
-					cStripsT.erase(this->cStrips[t].begin()+i);
+					cStripsT.erase(cStripsT.begin()+i);
 					i--;
 					r++;
@@ -160,11 +160,7 @@
 				if (!sigue && r)
 				{
-					if (regLOD.strip == this->MARCAVACIO)
-					{
-						regLOD.strip	=	t;
-					}
 					
-					++totalRegs;
-
+
+					/*
 					cDatos.push_back(p0);
 					cDatos.push_back(r);
@@ -172,4 +168,42 @@
 					r	=	0;
 					k	=	long(cStripsT.size()-r-3);
+					*/
+					long auxp0, auxr;
+					//regLOD.strip= t;
+					auxp0= p0;
+					auxr= r;
+						
+					if (r==1)
+					{
+						while(r>0)
+						{
+							cStripsT.insert(cStripsT.begin()+p0,cStripsT[p0]);
+							r--;
+						}
+						i=p0;
+					}					
+					else
+					{
+						if (r%2) //If r is odd the changes are undone
+						{
+							cStripsT.insert(cStripsT.begin()+p0,cStripsT[p0]);
+							r--;
+							auxr=r;
+						}
+						//listaPos.push_back(pos);
+						cDatos.push_back(auxp0);
+						cDatos.push_back(auxr);
+					if (regLOD.strip == this->MARCAVACIO)
+					{
+						regLOD.strip	=	t;
+					}
+
+					++totalRegs;
+					}
+
+
+					r= 0;
+					k=cStripsT.size()-3;
+
 				}
 
Index: GTP/trunk/Lib/Geom/shared/GeoTool/out.objf
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/out.objf	(revision 998)
+++ 	(revision )
@@ -1,1191 +1,0 @@
-#out.obj: a triangle strip representation created by STRIPE.
-#This is a .objf file
-#by Francine Evans
-
-t 33146 33143 33146 33154
-q 33153
-q 33152
-q 33151
-q 33150
-q 33149
-q 33148
-q 33147
-q 33145
-q 33144
-q 33143 33144
-q 33146
-q 33156 33146
-q 33160
-q 33153
-q 33159
-q 33151
-q 33158
-q 33149
-q 33157
-q 33147
-q 33155
-q 33144 33155
-q 33156
-q 33162 33156
-q 33166
-q 33160
-q 33165
-q 33159
-q 33164
-q 33158
-q 33163
-q 33157
-q 33161
-q 33155 33161
-q 33162
-q 33168 33162
-q 33172
-q 33166
-q 33171
-q 33165
-q 33170
-q 33164
-q 33169
-q 33163
-q 33167
-q 33161 33167
-q 33168
-q 33174 33168
-q 33178
-q 33172
-q 33177
-q 33171
-q 33176
-q 33170
-q 33175
-q 33169
-q 33173
-q 33167 33173
-q 33174 33173
-q 33180 33173
-q 33179
-q 33175
-q 33181
-q 33176
-q 33182
-q 33177
-q 33183
-q 33178
-q 33184
-q 33174 33184
-q 33180 33184
-q 33185
-q 33183 33185
-q 33182 33185
-q 33181 33185
-q 33179 33180
-t 33051 33043 33040
-q 33041
-q 33042
-q 33044
-q 33045
-q 33046
-q 33047
-q 33048
-q 33049
-q 33050
-q 33051 33050
-q 33043 33050
-q 33057 33050
-q 33056
-q 33048
-q 33055
-q 33046
-q 33054
-q 33044
-q 33052
-q 33041
-q 33053
-q 33043 33053
-q 33057
-q 33063 33057
-q 33062
-q 33056
-q 33061
-q 33055
-q 33060
-q 33054
-q 33058
-q 33052
-q 33059
-q 33053 33059
-q 33063
-q 33069 33063
-q 33068
-q 33062
-q 33067
-q 33061
-q 33066
-q 33060
-q 33064
-q 33058
-q 33065
-q 33059 33065
-q 33069
-q 33075 33069
-q 33074
-q 33068
-q 33073
-q 33067
-q 33072
-q 33066
-q 33070
-q 33064
-q 33071
-q 33065 33071
-q 33075
-q 33081 33075
-q 33080
-q 33074
-q 33079
-q 33073
-q 33078
-q 33072
-q 33076
-q 33070
-q 33077
-q 33071 33077
-q 33081
-q 33087 33081
-q 33086
-q 33080
-q 33085
-q 33079
-q 33084
-q 33078
-q 33082
-q 33076
-q 33083
-q 33077 33083
-q 33087
-q 33093 33087
-q 33092
-q 33086
-q 33091
-q 33085
-q 33090
-q 33084
-q 33088
-q 33082
-q 33089
-q 33083 33089
-q 33093 33089
-q 33099 33089
-q 33095
-q 33088
-q 33094
-q 33090
-q 33096
-q 33091
-q 33097
-q 33092
-q 33098
-q 33093 33098
-q 33099
-q 33104 33099
-q 33105
-q 33095
-q 33101
-q 33094
-q 33100
-q 33096
-q 33102
-q 33097
-q 33103
-q 33098 33103
-q 33104 33103
-q 33109 33103
-q 33108
-q 33102
-q 33106
-q 33100
-q 33107
-q 33101
-q 33111
-q 33105
-q 33110
-q 33104 33110
-q 33109 33110
-q 33115 33110
-q 33116
-q 33111
-q 33117
-q 33107
-q 33113
-q 33106
-q 33112
-q 33108
-q 33114
-q 33109 33114
-q 33115 33114
-q 33120 33114
-q 33118
-q 33112
-q 33119
-q 33113
-q 33123
-q 33117
-q 33122
-q 33116
-q 33121
-q 33115 33121
-q 33120
-q 33126 33120
-q 33124
-q 33118
-q 33125
-q 33119
-q 33129
-q 33123
-q 33128
-q 33122
-q 33127
-q 33121 33127
-q 33126
-q 33132 33126
-q 33130
-q 33124
-q 33131
-q 33125
-q 33135
-q 33129
-q 33134
-q 33128
-q 33133
-q 33127 33133
-q 33132 33133
-q 33138 33133
-q 33139
-q 33134
-q 33140
-q 33135
-q 33141
-q 33131
-q 33137
-q 33130
-q 33136
-q 33132 33136
-q 33138 33136
-q 33142
-q 33137 33142
-q 33141 33142
-q 33140 33142
-q 33139 33138
-t 32934 32931 32934 32942
-q 32941
-q 32940
-q 32939
-q 32938
-q 32937
-q 32936
-q 32935
-q 32933
-q 32932
-q 32931 32932
-q 32934
-q 32944 32934
-q 32948
-q 32941
-q 32947
-q 32939
-q 32946
-q 32937
-q 32945
-q 32935
-q 32943
-q 32932 32943
-q 32944
-q 32950 32944
-q 32954
-q 32948
-q 32953
-q 32947
-q 32952
-q 32946
-q 32951
-q 32945
-q 32949
-q 32943 32949
-q 32950 32949
-q 32956 32949
-q 32955
-q 32951
-q 32957
-q 32952
-q 32958
-q 32953
-q 32959
-q 32954
-q 32960
-q 32950 32960
-q 32956 32960
-q 32966 32960
-q 32965
-q 32959
-q 32964
-q 32958
-q 32963
-q 32957
-q 32961
-q 32955
-q 32962
-q 32956 32962
-q 32966
-q 32972 32966
-q 32971
-q 32965
-q 32970
-q 32964
-q 32969
-q 32963
-q 32967
-q 32961
-q 32968
-q 32962 32968
-q 32972
-q 32978 32972
-q 32977
-q 32971
-q 32976
-q 32970
-q 32975
-q 32969
-q 32973
-q 32967
-q 32974
-q 32968 32974
-q 32978
-q 32984 32978
-q 32983
-q 32977
-q 32982
-q 32976
-q 32981
-q 32975
-q 32979
-q 32973
-q 32980
-q 32974 32980
-q 32984
-q 32990 32984
-q 32989
-q 32983
-q 32988
-q 32982
-q 32987
-q 32981
-q 32985
-q 32979
-q 32986
-q 32980 32986
-q 32990
-q 32996 32990
-q 32995
-q 32989
-q 32994
-q 32988
-q 32993
-q 32987
-q 32991
-q 32985
-q 32992
-q 32986 32992
-q 32996 32992
-q 33002 32992
-q 32998
-q 32991
-q 32997
-q 32993
-q 32999
-q 32994
-q 33000
-q 32995
-q 33001
-q 32996 33001
-q 33002
-q 33007 33002
-q 33008
-q 32998
-q 33004
-q 32997
-q 33003
-q 32999
-q 33005
-q 33000
-q 33006
-q 33001 33006
-q 33007 33006
-q 33012 33006
-q 33011
-q 33005
-q 33009
-q 33003
-q 33010
-q 33004
-q 33014
-q 33008
-q 33013
-q 33007 33013
-q 33012
-q 33018 33012
-q 33017
-q 33011
-q 33015
-q 33009
-q 33016
-q 33010
-q 33020
-q 33014
-q 33019
-q 33013 33019
-q 33018
-q 33024 33018
-q 33023
-q 33017
-q 33021
-q 33015
-q 33022
-q 33016
-q 33026
-q 33020
-q 33025
-q 33019 33025
-q 33024
-q 33030 33024
-q 33029
-q 33023
-q 33027
-q 33021
-q 33028
-q 33022
-q 33032
-q 33026
-q 33031
-q 33025 33031
-q 33030
-q 33036 33030
-q 33035
-q 33029
-q 33033
-q 33027
-q 33034
-q 33028
-q 33038
-q 33032
-q 33037
-q 33031 33037
-q 33036
-q 33039
-q 33035 33039
-q 33033 33039
-q 33034 33039
-q 33038 33037
-t 32833 32825 32822
-q 32823
-q 32824
-q 32826
-q 32827
-q 32828
-q 32829
-q 32830
-q 32831
-q 32832
-q 32833 32832
-q 32825 32832
-q 32839 32832
-q 32838
-q 32830
-q 32837
-q 32828
-q 32836
-q 32826
-q 32834
-q 32823
-q 32835
-q 32825 32835
-q 32839
-q 32845 32839
-q 32844
-q 32838
-q 32843
-q 32837
-q 32842
-q 32836
-q 32840
-q 32834
-q 32841
-q 32835 32841
-q 32845
-q 32851 32845
-q 32850
-q 32844
-q 32849
-q 32843
-q 32848
-q 32842
-q 32846
-q 32840
-q 32847
-q 32841 32847
-q 32851
-q 32857 32851
-q 32856
-q 32850
-q 32855
-q 32849
-q 32854
-q 32848
-q 32852
-q 32846
-q 32853
-q 32847 32853
-q 32857
-q 32863 32857
-q 32862
-q 32856
-q 32861
-q 32855
-q 32860
-q 32854
-q 32858
-q 32852
-q 32859
-q 32853 32859
-q 32863
-q 32869 32863
-q 32868
-q 32862
-q 32867
-q 32861
-q 32866
-q 32860
-q 32864
-q 32858
-q 32865
-q 32859 32865
-q 32869 32865
-q 32875 32865
-q 32871
-q 32864
-q 32870
-q 32866
-q 32872
-q 32867
-q 32873
-q 32868
-q 32874
-q 32869 32874
-q 32875 32874
-q 32880 32874
-q 32879
-q 32873
-q 32878
-q 32872
-q 32876
-q 32870
-q 32877
-q 32871
-q 32881
-q 32875 32881
-q 32880
-q 32886 32880
-q 32885
-q 32879
-q 32884
-q 32878
-q 32882
-q 32876
-q 32883
-q 32877
-q 32887
-q 32881 32887
-q 32886
-q 32892 32886
-q 32891
-q 32885
-q 32890
-q 32884
-q 32888
-q 32882
-q 32889
-q 32883
-q 32893
-q 32887 32893
-q 32892
-q 32898 32892
-q 32897
-q 32891
-q 32896
-q 32890
-q 32894
-q 32888
-q 32895
-q 32889
-q 32899
-q 32893 32899
-q 32898
-q 32904 32898
-q 32903
-q 32897
-q 32902
-q 32896
-q 32900
-q 32894
-q 32901
-q 32895
-q 32905
-q 32899 32905
-q 32904
-q 32910 32904
-q 32909
-q 32903
-q 32908
-q 32902
-q 32906
-q 32900
-q 32907
-q 32901
-q 32911
-q 32905 32911
-q 32910
-q 32916 32910
-q 32915
-q 32909
-q 32914
-q 32908
-q 32912
-q 32906
-q 32913
-q 32907
-q 32917
-q 32911 32917
-q 32916
-q 32922 32916
-q 32921
-q 32915
-q 32920
-q 32914
-q 32918
-q 32912
-q 32919
-q 32913
-q 32923
-q 32917 32923
-q 32922 32923
-q 32928 32923
-q 32929
-q 32919
-q 32925
-q 32918
-q 32924
-q 32920
-q 32926
-q 32921
-q 32927
-q 32922 32927
-q 32928 32927
-q 32930
-q 32926 32930
-q 32924 32930
-q 32925 32930
-q 32929 32928
-t 32730 32722 32719
-q 32720
-q 32721
-q 32723
-q 32724
-q 32725
-q 32726
-q 32727
-q 32728
-q 32729
-q 32730 32729
-q 32722
-q 32736 32722
-q 32732
-q 32720
-q 32731
-q 32723
-q 32733
-q 32725
-q 32734
-q 32727
-q 32735
-q 32729 32735
-q 32736 32735
-q 32741 32735
-q 32740
-q 32734
-q 32739
-q 32733
-q 32737
-q 32731
-q 32738
-q 32732
-q 32742
-q 32736 32742
-q 32741 32742
-q 32747 32742
-q 32748
-q 32738
-q 32744
-q 32737
-q 32743
-q 32739
-q 32745
-q 32740
-q 32746
-q 32741 32746
-q 32747
-q 32752 32747
-q 32753
-q 32748
-q 32754
-q 32744
-q 32750
-q 32743
-q 32749
-q 32745
-q 32751
-q 32746 32751
-q 32752 32751
-q 32757 32751
-q 32755
-q 32749
-q 32756
-q 32750
-q 32760
-q 32754
-q 32759
-q 32753
-q 32758
-q 32752 32758
-q 32757
-q 32763 32757
-q 32761
-q 32755
-q 32762
-q 32756
-q 32766
-q 32760
-q 32765
-q 32759
-q 32764
-q 32758 32764
-q 32763
-q 32769 32763
-q 32767
-q 32761
-q 32768
-q 32762
-q 32772
-q 32766
-q 32771
-q 32765
-q 32770
-q 32764 32770
-q 32769
-q 32775 32769
-q 32773
-q 32767
-q 32774
-q 32768
-q 32778
-q 32772
-q 32777
-q 32771
-q 32776
-q 32770 32776
-q 32775
-q 32781 32775
-q 32779
-q 32773
-q 32780
-q 32774
-q 32784
-q 32778
-q 32783
-q 32777
-q 32782
-q 32776 32782
-q 32781 32782
-q 32787 32782
-q 32788
-q 32783
-q 32789
-q 32784
-q 32790
-q 32780
-q 32786
-q 32779
-q 32785
-q 32781 32785
-q 32787
-q 32791 32787
-q 32793
-q 32788
-q 32794
-q 32789
-q 32795
-q 32790
-q 32796
-q 32786
-q 32792
-q 32785 32792
-q 32791 32792
-q 32798 32792
-q 32802
-q 32796
-q 32801
-q 32795
-q 32800
-q 32794
-q 32799
-q 32793
-q 32797
-q 32791 32797
-q 32798
-q 32804 32798
-q 32808
-q 32802
-q 32807
-q 32801
-q 32806
-q 32800
-q 32805
-q 32799
-q 32803
-q 32797 32803
-q 32804
-q 32810 32804
-q 32814
-q 32808
-q 32813
-q 32807
-q 32812
-q 32806
-q 32811
-q 32805
-q 32809
-q 32803 32809
-q 32810
-q 32816 32810
-q 32820
-q 32814
-q 32819
-q 32813
-q 32818
-q 32812
-q 32817
-q 32811
-q 32815
-q 32809 32815
-q 32816
-q 32821
-q 32820 32821
-q 32819 32821
-q 32818 32821
-q 32817 32815
-t 32639 32631 32628
-q 32629
-q 32630
-q 32632
-q 32633
-q 32634
-q 32635
-q 32636
-q 32637
-q 32638
-q 32639 32638
-q 32631 32638
-q 32645 32638
-q 32644
-q 32636
-q 32643
-q 32634
-q 32642
-q 32632
-q 32640
-q 32629
-q 32641
-q 32631 32641
-q 32645
-q 32651 32645
-q 32650
-q 32644
-q 32649
-q 32643
-q 32648
-q 32642
-q 32646
-q 32640
-q 32647
-q 32641 32647
-q 32651 32647
-q 32657 32647
-q 32653
-q 32646
-q 32652
-q 32648
-q 32654
-q 32649
-q 32655
-q 32650
-q 32656
-q 32651 32656
-q 32657
-q 32662 32657
-q 32663
-q 32653
-q 32659
-q 32652
-q 32658
-q 32654
-q 32660
-q 32655
-q 32661
-q 32656 32661
-q 32662 32661
-q 32667 32661
-q 32666
-q 32660
-q 32664
-q 32658
-q 32665
-q 32659
-q 32669
-q 32663
-q 32668
-q 32662 32668
-q 32667
-q 32673 32667
-q 32672
-q 32666
-q 32670
-q 32664
-q 32671
-q 32665
-q 32675
-q 32669
-q 32674
-q 32668 32674
-q 32673
-q 32679 32673
-q 32678
-q 32672
-q 32676
-q 32670
-q 32677
-q 32671
-q 32681
-q 32675
-q 32680
-q 32674 32680
-q 32679
-q 32685 32679
-q 32684
-q 32678
-q 32682
-q 32676
-q 32683
-q 32677
-q 32687
-q 32681
-q 32686
-q 32680 32686
-q 32685 32686
-q 32691 32686
-q 32692
-q 32687
-q 32693
-q 32683
-q 32689
-q 32682
-q 32688
-q 32684
-q 32690
-q 32685 32690
-q 32691 32690
-q 32696 32690
-q 32694
-q 32688
-q 32695
-q 32689
-q 32699
-q 32693
-q 32698
-q 32692
-q 32697
-q 32691 32697
-q 32696
-q 32702 32696
-q 32700
-q 32694
-q 32701
-q 32695
-q 32705
-q 32699
-q 32704
-q 32698
-q 32703
-q 32697 32703
-q 32702
-q 32708 32702
-q 32706
-q 32700
-q 32707
-q 32701
-q 32711
-q 32705
-q 32710
-q 32704
-q 32709
-q 32703 32709
-q 32708 32709
-q 32714 32709
-q 32715
-q 32710
-q 32716
-q 32711
-q 32717
-q 32707
-q 32713
-q 32706
-q 32712
-q 32708 32712
-q 32714 32712
-q 32718
-q 32713 32718
-q 32717 32718
-q 32716 32718
-q 32715 32714
-t 32564 32561 32564 32572
-q 32571
-q 32570
-q 32569
-q 32568
-q 32567
-q 32566
-q 32565
-q 32563
-q 32562
-q 32561 32562
-q 32564
-q 32574 32564
-q 32578
-q 32571
-q 32577
-q 32569
-q 32576
-q 32567
-q 32575
-q 32565
-q 32573
-q 32562 32573
-q 32574 32573
-q 32580 32573
-q 32579
-q 32575
-q 32581
-q 32576
-q 32582
-q 32577
-q 32583
-q 32578
-q 32584
-q 32574 32584
-q 32580 32584
-q 32590 32584
-q 32589
-q 32583
-q 32588
-q 32582
-q 32587
-q 32581
-q 32585
-q 32579
-q 32586
-q 32580 32586
-q 32590
-q 32596 32590
-q 32595
-q 32589
-q 32594
-q 32588
-q 32593
-q 32587
-q 32591
-q 32585
-q 32592
-q 32586 32592
-q 32596
-q 32602 32596
-q 32601
-q 32595
-q 32600
-q 32594
-q 32599
-q 32593
-q 32597
-q 32591
-q 32598
-q 32592 32598
-q 32602
-q 32608 32602
-q 32607
-q 32601
-q 32606
-q 32600
-q 32605
-q 32599
-q 32603
-q 32597
-q 32604
-q 32598 32604
-q 32608 32604
-q 32614 32604
-q 32610
-q 32603
-q 32609
-q 32605
-q 32611
-q 32606
-q 32612
-q 32607
-q 32613
-q 32608 32613
-q 32614 32613
-q 32619 32613
-q 32618
-q 32612
-q 32617
-q 32611
-q 32615
-q 32609
-q 32616
-q 32610
-q 32620
-q 32614 32620
-q 32619
-q 32625 32619
-q 32624
-q 32618
-q 32623
-q 32617
-q 32621
-q 32615
-q 32622
-q 32616
-q 32626
-q 32620 32626
-q 32625
-q 32627
-q 32624 32627
-q 32623 32627
-q 32621 32627
-q 32622 32626